# Changes planned from Beta -> RC:

* [ ] Look into package size reduction, extract optional modules, e.g
  * createFilter could be optional, saving 2.6k gz
  * vendor simple Menu by default, allow opt-in to advanced usage
* [ ] Bind getStyles for each component

---

# Order of focus:

* [ ] Review how the `required` state of the `<input>` can be handled
* [ ] Example of how to implement Separators
* [ ] Handle Header and Footer elements in the Menu
* [ ] Keyboard focusing of values in multi select

---

# Review:

### Select Component Props

* [ ] `backspaceToRemoveMessage` _investigate_
* [x] `className` _investigate_ might need to move the className util into commonProps
* [x] `openOnClick` / `openOnFocus` needs implementation
* [ ] `required` _|||_ this has some complex behaviour in v1 which may or may not be needed
* [x] `tabIndex` needs implementation

#### Done

* [x] `id`
* [x] `inputId` falls back to `react-select-${props.instanceId}-input`
* [x] `autoBlur` **REMOVED** can be handled with `onChange`
* [x] `autosize` **REMOVED** can replace `<Input />` component
* [x] `onClose` --> `onMenuClose`
* [x] `onOpen` --> `onMenuOpen`
* [x] `onBlurResetsInput` / `onCloseResetsInput` / `onSelectResetsInput` **REMOVED** now that `inputValue` can be controlled, these should be unnecessary
* [x] `onMenuScrollToBottom` implemented
* [x] `clearable` --> `isClearable`
* [x] `rtl` --> `isRTL`
* [x] `pageSize`
* [x] `menuShouldScrollIntoView`
* [x] `searchable` --> `isSearchable`
* [x] `resetValue` **REMOVED** can be handled with `onInputChange`
* [x] `clearAllText` / `clearValueText` **REMOVED** title no longer applied, can replace `<ClearIndicator />`

### Async Component Props

* [ ] `autoLoad` _investigate_ should be considered in conjunction with `searchPromptText`, may affect `defaultOptions` behaviour
* [ ] `searchPromptText` _investigate_ how do we know to display it? (https://goo.gl/PLTwV5)

---

# Maybe:

* [ ] Virtualisation
* [ ] Prevent values from being popped, was `option.clearableValue === false`
* [ ] Async w/ pagination
* [ ] Extention point to reorder / change menu options array when it's created

---

# Later:

* [ ] Reordering of Options (drag and drop)

---

# Done:

* [x] Tags mode (Creatable)
* [x] Handle changing of isDisabled prop
* [x] Better mobile support and touch handling
* [x] Better control of flip behaviour
* [x] Scroll the menu into view when it opens
* [x] Handle touch outside (see v1 implementation)
* [x] Review implementation of `isSearchable` prop (creates a "fake" input)
* [x] Async + Creatable variant
* [x] Cleanup
* [x] Documentation - Props, Customisation
* [x] Upgrade Guide from v1 -> v2
* [x] Lock scrolling on Menu (enable with prop)
* [x] Make inputValue a controllable prop
* [x] Make menuIsOpen a controllable prop
* [x] Finalise theme and style customisation framework
* [x] Remove `disabledKey`, clean up similar functionality
* [x] Pseudo-focus Options
* [x] Keyboard navigation
* [x] Make `isDisabled` / `isSelected` etc. props
* [x] Scroll to focused option
* [x] Add `autofocus` prop
* [x] Add HTML Form Input
* [x] Async with:
* [x] * promises
* [x] * better loading state and behaviour
* [x] Pass more (and consistent?) props and state from Select to Components
* [x] Fix issue with how the mouse hover interacts with keyboard scrolling
* [x] Ability to customise built-in strings
